//+------------------------------------------------------------------+
//|                                                    TDI_BB_EA.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, TDI_BB"
#property link      "https://www.Fiverr.com/coolzy"
#property version   "1.00"
#property description ""

#include <stdlib.mqh>
#include <stderror.mqh>

extern double LotSize    = 0.1;
extern double Stoploss   = 100;
extern double Takeprofit = 50;

extern string BB_Indicator_settings=" ";
extern int    BB_Period = 20;
extern double BB_Deviations = 2;
extern int    Bands_shift = 0;

extern string TDI_Indicator_settings=" ";
extern int    RSI_Period        =13; //8-25
extern ENUM_APPLIED_PRICE   Applied_price  = PRICE_CLOSE;     //Applied price
extern int    Volatility_Band   =34; //20-40
extern int    RSI_Price_Line    =2;
extern  ENUM_MA_METHOD   RSI_Price_Type    = MODE_SMA;  //0-3
extern int    Trade_Signal_Line =7;
extern int    Trade_Signal_Type =0;  //0-3
extern int    TDI_Upper_Level   = 75;
extern int    TDI_Lower_Level   = 25;



extern string Trailing_Stop_settings=" ";
extern bool   Use_Trailing_Stop    = false;
extern double TrailingStop_pips    = 10;
extern double Trail_Step=5;


int LotDigits; 
int MagicNumber = 1952142;

int MaxSlippage = 3; 
int MaxOpenTrades = 1;
int MaxLongTrades = 1;
int MaxShortTrades = 1;
int MaxPendingOrders = 1000;
bool Hedging = true;
int OrderRetry = 5; 
int OrderWait = 5; 
double myPoint; 
double PriceTooClose=10;



//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {   
   //initialize myPoint
   myPoint = Point();
   if(Digits() == 5 || Digits() == 3)
     {
      myPoint *= 10;
      MaxSlippage *= 10;
     }
   //initialize LotDigits
   double LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
   if(LotStep >= 1) LotDigits = 0;
   else if(LotStep >= 0.1) LotDigits = 1;
   else if(LotStep >= 0.01) LotDigits = 2;
   else LotDigits = 3;
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   int ticket = -1;
   double price;   
   double SL;
   double TP;
   
   if(Use_Trailing_Stop) TrailingStopTrail(OP_BUY,TrailingStop_pips*myPoint,Trail_Step*myPoint,true);

   if(Use_Trailing_Stop) TrailingStopTrail(OP_SELL,TrailingStop_pips*myPoint,Trail_Step*myPoint,true);
   
   
   
   //Open Buy Order
  if(Close[1] < iBands(NULL, PERIOD_CURRENT, BB_Period, BB_Deviations, Bands_shift, PRICE_CLOSE, MODE_LOWER, 0)&& TDI_Cross(1)== 2 )
     {
      RefreshRates();
      price = Ask;
      SL = Stoploss * myPoint; 
      TP = Takeprofit * myPoint;  
      if(IsTradeAllowed())
        {
         ticket = myOrderSend(OP_BUY, price, LotSize  , "");
         if(ticket <= 0) return;
        }
      else //not autotrading => only send alert
         myAlert("order", "");
      myOrderModifyRel(ticket, SL, 0);
      myOrderModifyRel(ticket, 0, TP);
     }
   
   //Open Sell Order
    if(Close[1] > iBands(NULL, PERIOD_CURRENT, BB_Period, BB_Deviations, Bands_shift, PRICE_CLOSE, MODE_UPPER, 0) && TDI_Cross(1)== 1 )
   
     {
      RefreshRates();
      price = Bid;
      SL = Stoploss * myPoint; 
      TP = Takeprofit * myPoint; 
      if(IsTradeAllowed())
        {
         ticket = myOrderSend(OP_SELL, price, LotSize  , "");
         if(ticket <= 0) return;
        }
      else //not autotrading => only send alert
         myAlert("order", "");
      myOrderModifyRel(ticket, SL, 0);
      myOrderModifyRel(ticket, 0, TP);
     }
  }
//+------------------------------------------------------------------+



void myAlert(string type, string message)
  {
   if(type == "print")
      Print(message);
   else if(type == "error")
     {
      Print(type+" | pending delete22 @ "+Symbol()+","+Period()+" | "+message);
     }
   else if(type == "order")
     {
     }
   else if(type == "modify")
     {
     }
  }

int TradesCount(int type) //returns # of open trades for order type, current symbol and magic number
  {
   int result = 0;
   int total = OrdersTotal();
   for(int i = 0; i < total; i++)
     {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) continue;
      if(OrderMagicNumber() != MagicNumber || OrderSymbol() != Symbol() || OrderType() != type) continue;
      result++;
     }
   return(result);
  }

int myOrderSend(int type, double price, double volume, string ordername) //send order, return ticket ("price" is irrelevant for market orders)
  {
   if(!IsTradeAllowed()) return(-1);
   int ticket = -1;
   int retries = 0;
   int err;
   int long_trades = TradesCount(OP_BUY);
   int short_trades = TradesCount(OP_SELL);
   int long_pending = TradesCount(OP_BUYLIMIT) + TradesCount(OP_BUYSTOP);
   int short_pending = TradesCount(OP_SELLLIMIT) + TradesCount(OP_SELLSTOP);
   string ordername_ = ordername;
   if(ordername != "")
      ordername_ = "("+ordername+")";
   //test Hedging
   if(!Hedging && ((type % 2 == 0 && short_trades + short_pending > 0) || (type % 2 == 1 && long_trades + long_pending > 0)))
     {
      myAlert("print", "Order"+ordername_+" not sent, hedging not allowed");
      return(-1);
     }
   //test maximum trades
   if((type % 2 == 0 && long_trades >= MaxLongTrades)
   || (type % 2 == 1 && short_trades >= MaxShortTrades)
   || (long_trades + short_trades >= MaxOpenTrades)
   || (type > 1 && long_pending + short_pending >= MaxPendingOrders))
     {
      
      return(-1);
     }
   //prepare to send order
   while(IsTradeContextBusy()) Sleep(100);
   RefreshRates();
   if(type == OP_BUY)
      price = Ask;
   else if(type == OP_SELL)
      price = Bid;
   else if(price < 0) //invalid price for pending order
     {
      myAlert("order", "Order"+ordername_+" not sent, invalid price for pending order");
	  return(-1);
     }
   int clr = (type % 2 == 1) ? clrRed : clrBlue;
   while(ticket < 0 && retries < OrderRetry+1)
     {
      ticket = OrderSend(Symbol(), type, NormalizeDouble(volume, LotDigits), NormalizeDouble(price, Digits()), MaxSlippage, 0, 0, ordername, MagicNumber, 0, clr);
      if(ticket < 0)
        {
         err = GetLastError();
         myAlert("print", "OrderSend"+ordername_+" error #"+err+" "+ErrorDescription(err));
         Sleep(OrderWait*1000);
        }
      retries++;
     }
   if(ticket < 0)
     {
      myAlert("error", "OrderSend"+ordername_+" failed "+(OrderRetry+1)+" times; error #"+err+" "+ErrorDescription(err));
      return(-1);
     }
   string typestr[6] = {"Buy", "Sell", "Buy Limit", "Sell Limit", "Buy Stop", "Sell Stop"};
   myAlert("order", "Order sent"+ordername_+": "+typestr[type]+" "+Symbol()+" Magic #"+MagicNumber);
   return(ticket);
  }

int myOrderModifyRel(int ticket, double SL, double TP) //modify SL and TP (relative to open price), zero targets do not modify
  {
   if(!IsTradeAllowed()) return(-1);
   bool success = false;
   int retries = 0;
   int err;
   SL = NormalizeDouble(SL, Digits());
   TP = NormalizeDouble(TP, Digits());
   if(SL < 0) SL = 0;
   if(TP < 0) TP = 0;
   //prepare to select order
   while(IsTradeContextBusy()) Sleep(100);
   if(!OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
     {
      err = GetLastError();
      myAlert("error", "OrderSelect failed; error #"+err+" "+ErrorDescription(err));
      return(-1);
     }
   //prepare to modify order
   while(IsTradeContextBusy()) Sleep(100);
   RefreshRates();
   //convert relative to absolute
   if(OrderType() % 2 == 0) //buy
     {
      if(NormalizeDouble(SL, Digits()) != 0)
         SL = OrderOpenPrice() - SL;
      if(NormalizeDouble(TP, Digits()) != 0)
         TP = OrderOpenPrice() + TP;
     }
   else //sell
     {
      if(NormalizeDouble(SL, Digits()) != 0)
         SL = OrderOpenPrice() + SL;
      if(NormalizeDouble(TP, Digits()) != 0)
         TP = OrderOpenPrice() - TP;
     }
   if(CompareDoubles(SL, 0)) SL = OrderStopLoss(); //not to modify
   if(CompareDoubles(TP, 0)) TP = OrderTakeProfit(); //not to modify
   if(CompareDoubles(SL, OrderStopLoss()) && CompareDoubles(TP, OrderTakeProfit())) return(0); //nothing to do
   while(!success && retries < OrderRetry+1)
     {
      success = OrderModify(ticket, NormalizeDouble(OrderOpenPrice(), Digits()), NormalizeDouble(SL, Digits()), NormalizeDouble(TP, Digits()), OrderExpiration(), CLR_NONE);
      if(!success)
        {
         err = GetLastError();
         myAlert("print", "OrderModify error #"+err+" "+ErrorDescription(err));
         Sleep(OrderWait*1000);
        }
      retries++;
     }
   if(!success)
     {
      myAlert("error", "OrderModify failed "+(OrderRetry+1)+" times; error #"+err+" "+ErrorDescription(err));
      return(-1);
     }
   string alertstr = "Order modified: ticket="+ticket;
   if(!CompareDoubles(SL, 0)) alertstr = alertstr+" SL="+SL;
   if(!CompareDoubles(TP, 0)) alertstr = alertstr+" TP="+TP;
   myAlert("modify", alertstr);
   return(0);
  }



int TDI_Cross(int _shift)
{
  double PriceLine = iCustom(_Symbol,PERIOD_CURRENT,"TDI_v102",RSI_Period,Applied_price,RSI_Price_Line,Trade_Signal_Line,Trade_Signal_Type,4,_shift);
   if(PriceLine >= TDI_Upper_Level ) return(1);
   if(PriceLine <= TDI_Lower_Level ) return(2);

   return(0);

}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void TrailingStopTrail(int type,double TS,double step,bool aboveBE) //set Stop Loss to "TS" if price is going your way with "step"
  {
   int total=OrdersTotal();
   TS=NormalizeDouble(TS,Digits());
   step=NormalizeDouble(step,Digits());
   for(int i=total-1; i>=0; i--)
     {
      while(IsTradeContextBusy()) Sleep(100);
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
      if(OrderSymbol()!=Symbol() || OrderType()!=type) continue;
      RefreshRates();
      if(type==OP_BUY && (!aboveBE || Bid>OrderOpenPrice()+TS) && (NormalizeDouble(OrderStopLoss(),Digits())<=0 || Bid>OrderStopLoss()+TS+step))
         myOrderModify(OrderTicket(),Bid-TS,0);
      else if(type==OP_SELL && (!aboveBE || Ask<OrderOpenPrice()-TS) && (NormalizeDouble(OrderStopLoss(),Digits())<=0 || Ask<OrderStopLoss()-TS-step))
      myOrderModify(OrderTicket(),Ask+TS,0);
     }
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int myOrderModify(int ticket,double SL,double TP) //modify SL and TP (absolute price), zero targets do not modify
  {
   if(!IsTradeAllowed()) return(-1);
   bool success= false;
   int retries = 0;
   int err;
   SL = NormalizeDouble(SL, Digits());
   TP = NormalizeDouble(TP, Digits());
   if(SL < 0) SL = 0;
   if(TP < 0) TP = 0;
//prepare to select order
   while(IsTradeContextBusy()) Sleep(100);
   if(!OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
     {
      err=GetLastError();
      myAlert("error","OrderSelect failed; error #"+err+" "+ErrorDescription(err));
      return(-1);
     }
//prepare to modify order
   while(IsTradeContextBusy()) Sleep(100);
   RefreshRates();
//adjust targets for market order if too close to the market price
   double MinDistance=PriceTooClose*myPoint;
   if(OrderType()==OP_BUY)
     {
      if(NormalizeDouble(SL,Digits())!=0 && Ask-SL<MinDistance)
         SL=Ask-MinDistance;
      if(NormalizeDouble(TP,Digits())!=0 && TP-Ask<MinDistance)
         TP=Ask+MinDistance;
     }
   else if(OrderType()==OP_SELL)
     {
      if(NormalizeDouble(SL,Digits())!=0 && SL-Bid<MinDistance)
         SL=Bid+MinDistance;
      if(NormalizeDouble(TP,Digits())!=0 && Bid-TP<MinDistance)
         TP=Bid-MinDistance;
     }
   if(CompareDoubles(SL,0)) SL=OrderStopLoss(); //not to modify
   if(CompareDoubles(TP,0)) TP=OrderTakeProfit(); //not to modify
   if(CompareDoubles(SL,OrderStopLoss()) && CompareDoubles(TP,OrderTakeProfit())) return(0); //nothing to do
   while(!success && retries<OrderRetry+1)
     {
      success=OrderModify(ticket,NormalizeDouble(OrderOpenPrice(),Digits()),NormalizeDouble(SL,Digits()),NormalizeDouble(TP,Digits()),OrderExpiration(),CLR_NONE);
      if(!success)
        {
         err=GetLastError();
         myAlert("print","OrderModify error #"+err+" "+ErrorDescription(err));
         Sleep(OrderWait*1000);
        }
      retries++;
     }
   if(!success)
     {
      myAlert("error","OrderModify failed "+(OrderRetry+1)+" times; error #"+err+" "+ErrorDescription(err));
      return(-1);
     }
   string alertstr="Order modified: ticket="+ticket;
   if(!CompareDoubles(SL, 0)) alertstr = alertstr+" SL="+SL;
   if(!CompareDoubles(TP, 0)) alertstr = alertstr+" TP="+TP;
   myAlert("modify",alertstr);
   return(0);
  }  